<?php

namespace PHPMaker2021\rdigital21;

use Doctrine\DBAL\ParameterType;

/**
 * Table class for proyek
 */
class Proyek extends DbTable
{
    protected $SqlFrom = "";
    protected $SqlSelect = null;
    protected $SqlSelectList = null;
    protected $SqlWhere = "";
    protected $SqlGroupBy = "";
    protected $SqlHaving = "";
    protected $SqlOrderBy = "";
    public $UseSessionForListSql = true;

    // Column CSS classes
    public $LeftColumnClass = "col-sm-2 col-form-label ew-label";
    public $RightColumnClass = "col-sm-10";
    public $OffsetColumnClass = "col-sm-10 offset-sm-2";
    public $TableLeftColumnClass = "w-col-2";

    // Export
    public $ExportDoc;

    // Fields
    public $project_id;
    public $tahun_pelajaran;
    public $kelas;
    public $project;
    public $nama_proyek;
    public $tema;
    public $dimensi;
    public $deskripsi_proyek;

    // Page ID
    public $PageID = ""; // To be overridden by subclass

    // Constructor
    public function __construct()
    {
        global $Language, $CurrentLanguage;
        parent::__construct();

        // Language object
        $Language = Container("language");
        $this->TableVar = 'proyek';
        $this->TableName = 'proyek';
        $this->TableType = 'TABLE';

        // Update Table
        $this->UpdateTable = "\"proyek\"";
        $this->Dbid = 'DB';
        $this->ExportAll = true;
        $this->ExportPageBreakCount = 0; // Page break per every n record (PDF only)
        $this->ExportPageOrientation = "portrait"; // Page orientation (PDF only)
        $this->ExportPageSize = "a4"; // Page size (PDF only)
        $this->ExportExcelPageOrientation = ""; // Page orientation (PhpSpreadsheet only)
        $this->ExportExcelPageSize = ""; // Page size (PhpSpreadsheet only)
        $this->ExportWordPageOrientation = "portrait"; // Page orientation (PHPWord only)
        $this->ExportWordColumnWidth = null; // Cell width (PHPWord only)
        $this->DetailAdd = false; // Allow detail add
        $this->DetailEdit = false; // Allow detail edit
        $this->DetailView = false; // Allow detail view
        $this->ShowMultipleDetails = false; // Show multiple details
        $this->GridAddRowCount = 5;
        $this->AllowAddDeleteRow = true; // Allow add/delete row
        $this->UserIDAllowSecurity = Config("DEFAULT_USER_ID_ALLOW_SECURITY"); // Default User ID allowed permissions
        $this->BasicSearch = new BasicSearch($this->TableVar);

        // project_id
        $this->project_id = new DbField('proyek', 'proyek', 'x_project_id', 'project_id', '"project_id"', '"project_id"', 3, 0, -1, false, '"project_id"', false, false, false, 'FORMATTED TEXT', 'NO');
        $this->project_id->IsAutoIncrement = true; // Autoincrement field
        $this->project_id->IsPrimaryKey = true; // Primary key field
        $this->project_id->Sortable = true; // Allow sort
        $this->project_id->DefaultErrorMessage = $Language->phrase("IncorrectInteger");
        $this->project_id->CustomMsg = $Language->FieldPhrase($this->TableVar, $this->project_id->Param, "CustomMsg");
        $this->Fields['project_id'] = &$this->project_id;

        // tahun_pelajaran
        $this->tahun_pelajaran = new DbField('proyek', 'proyek', 'x_tahun_pelajaran', 'tahun_pelajaran', '"tahun_pelajaran"', '"tahun_pelajaran"', 202, 255, -1, false, '"tahun_pelajaran"', false, false, false, 'FORMATTED TEXT', 'SELECT');
        $this->tahun_pelajaran->Sortable = true; // Allow sort
        $this->tahun_pelajaran->UsePleaseSelect = true; // Use PleaseSelect by default
        $this->tahun_pelajaran->PleaseSelectText = $Language->phrase("PleaseSelect"); // "PleaseSelect" text
        $this->tahun_pelajaran->Lookup = new Lookup('tahun_pelajaran', 'tahun_pelajaran', true, 'tahun_pelajaran', ["tahun_pelajaran","","",""], [], [], [], [], [], [], '', '');
        $this->tahun_pelajaran->CustomMsg = $Language->FieldPhrase($this->TableVar, $this->tahun_pelajaran->Param, "CustomMsg");
        $this->Fields['tahun_pelajaran'] = &$this->tahun_pelajaran;

        // kelas
        $this->kelas = new DbField('proyek', 'proyek', 'x_kelas', 'kelas', '"kelas"', '"kelas"', 203, 0, -1, false, '"kelas"', false, false, false, 'FORMATTED TEXT', 'SELECT');
        $this->kelas->IsForeignKey = true; // Foreign key field
        $this->kelas->Sortable = true; // Allow sort
        $this->kelas->UsePleaseSelect = true; // Use PleaseSelect by default
        $this->kelas->PleaseSelectText = $Language->phrase("PleaseSelect"); // "PleaseSelect" text
        $this->kelas->Lookup = new Lookup('kelas', 'proyek', true, 'kelas', ["kelas","","",""], [], [], [], [], [], [], '"kelas" ASC', '');
        $this->kelas->CustomMsg = $Language->FieldPhrase($this->TableVar, $this->kelas->Param, "CustomMsg");
        $this->Fields['kelas'] = &$this->kelas;

        // project
        $this->project = new DbField('proyek', 'proyek', 'x_project', 'project', '"project"', '"project"', 202, 255, -1, false, '"project"', false, false, false, 'FORMATTED TEXT', 'SELECT');
        $this->project->IsForeignKey = true; // Foreign key field
        $this->project->Sortable = true; // Allow sort
        $this->project->UsePleaseSelect = true; // Use PleaseSelect by default
        $this->project->PleaseSelectText = $Language->phrase("PleaseSelect"); // "PleaseSelect" text
        $this->project->Lookup = new Lookup('project', 'proyek', false, '', ["","","",""], [], [], [], [], [], [], '', '');
        $this->project->OptionCount = 3;
        $this->project->CustomMsg = $Language->FieldPhrase($this->TableVar, $this->project->Param, "CustomMsg");
        $this->Fields['project'] = &$this->project;

        // nama_proyek
        $this->nama_proyek = new DbField('proyek', 'proyek', 'x_nama_proyek', 'nama_proyek', '"nama_proyek"', '"nama_proyek"', 202, 255, -1, false, '"nama_proyek"', false, false, false, 'FORMATTED TEXT', 'TEXT');
        $this->nama_proyek->Sortable = true; // Allow sort
        $this->nama_proyek->CustomMsg = $Language->FieldPhrase($this->TableVar, $this->nama_proyek->Param, "CustomMsg");
        $this->Fields['nama_proyek'] = &$this->nama_proyek;

        // tema
        $this->tema = new DbField('proyek', 'proyek', 'x_tema', 'tema', '"tema"', '"tema"', 202, 255, -1, false, '"tema"', false, false, false, 'FORMATTED TEXT', 'SELECT');
        $this->tema->Sortable = true; // Allow sort
        $this->tema->UsePleaseSelect = true; // Use PleaseSelect by default
        $this->tema->PleaseSelectText = $Language->phrase("PleaseSelect"); // "PleaseSelect" text
        $this->tema->Lookup = new Lookup('tema', 'tema', false, 'tema_id', ["tema","","",""], [], [], [], [], [], [], '', '');
        $this->tema->CustomMsg = $Language->FieldPhrase($this->TableVar, $this->tema->Param, "CustomMsg");
        $this->Fields['tema'] = &$this->tema;

        // dimensi
        $this->dimensi = new DbField('proyek', 'proyek', 'x_dimensi', 'dimensi', '"dimensi"', '"dimensi"', 203, 0, -1, false, '"dimensi"', false, false, false, 'FORMATTED TEXT', 'SELECT');
        $this->dimensi->Sortable = true; // Allow sort
        $this->dimensi->SelectMultiple = true; // Multiple select
        $this->dimensi->Lookup = new Lookup('dimensi', 'dimensi', false, 'dimensi_id', ["dimensi","sub_elemen","",""], [], [], [], [], [], [], '', '<div><b><span class="text-primary">{{:df1}}</span></b>, {{:df2}}</div>');
        $this->dimensi->CustomMsg = $Language->FieldPhrase($this->TableVar, $this->dimensi->Param, "CustomMsg");
        $this->Fields['dimensi'] = &$this->dimensi;

        // deskripsi_proyek
        $this->deskripsi_proyek = new DbField('proyek', 'proyek', 'x_deskripsi_proyek', 'deskripsi_proyek', '"deskripsi_proyek"', '"deskripsi_proyek"', 202, 255, -1, false, '"deskripsi_proyek"', false, false, false, 'FORMATTED TEXT', 'TEXTAREA');
        $this->deskripsi_proyek->Sortable = true; // Allow sort
        $this->deskripsi_proyek->CustomMsg = $Language->FieldPhrase($this->TableVar, $this->deskripsi_proyek->Param, "CustomMsg");
        $this->Fields['deskripsi_proyek'] = &$this->deskripsi_proyek;
    }

    // Field Visibility
    public function getFieldVisibility($fldParm)
    {
        global $Security;
        return $this->$fldParm->Visible; // Returns original value
    }

    // Set left column class (must be predefined col-*-* classes of Bootstrap grid system)
    public function setLeftColumnClass($class)
    {
        if (preg_match('/^col\-(\w+)\-(\d+)$/', $class, $match)) {
            $this->LeftColumnClass = $class . " col-form-label ew-label";
            $this->RightColumnClass = "col-" . $match[1] . "-" . strval(12 - (int)$match[2]);
            $this->OffsetColumnClass = $this->RightColumnClass . " " . str_replace("col-", "offset-", $class);
            $this->TableLeftColumnClass = preg_replace('/^col-\w+-(\d+)$/', "w-col-$1", $class); // Change to w-col-*
        }
    }

    // Single column sort
    public function updateSort(&$fld)
    {
        if ($this->CurrentOrder == $fld->Name) {
            $sortField = $fld->Expression;
            $lastSort = $fld->getSort();
            if (in_array($this->CurrentOrderType, ["ASC", "DESC", "NO"])) {
                $curSort = $this->CurrentOrderType;
            } else {
                $curSort = $lastSort;
            }
            $fld->setSort($curSort);
            $orderBy = in_array($curSort, ["ASC", "DESC"]) ? $sortField . " " . $curSort : "";
            $this->setSessionOrderBy($orderBy); // Save to Session
        } else {
            $fld->setSort("");
        }
    }

    // Current detail table name
    public function getCurrentDetailTable()
    {
        return Session(PROJECT_NAME . "_" . $this->TableVar . "_" . Config("TABLE_DETAIL_TABLE"));
    }

    public function setCurrentDetailTable($v)
    {
        $_SESSION[PROJECT_NAME . "_" . $this->TableVar . "_" . Config("TABLE_DETAIL_TABLE")] = $v;
    }

    // Get detail url
    public function getDetailUrl()
    {
        // Detail url
        $detailUrl = "";
        if ($this->getCurrentDetailTable() == "nilai_p5") {
            $detailUrl = Container("nilai_p5")->getListUrl() . "?" . Config("TABLE_SHOW_MASTER") . "=" . $this->TableVar;
            $detailUrl .= "&" . GetForeignKeyUrl("fk_kelas", $this->kelas->CurrentValue);
            $detailUrl .= "&" . GetForeignKeyUrl("fk_project", $this->project->CurrentValue);
        }
        if ($detailUrl == "") {
            $detailUrl = "ProyekList";
        }
        return $detailUrl;
    }

    // Table level SQL
    public function getSqlFrom() // From
    {
        return ($this->SqlFrom != "") ? $this->SqlFrom : "\"proyek\"";
    }

    public function sqlFrom() // For backward compatibility
    {
        return $this->getSqlFrom();
    }

    public function setSqlFrom($v)
    {
        $this->SqlFrom = $v;
    }

    public function getSqlSelect() // Select
    {
        return $this->SqlSelect ?? $this->getQueryBuilder()->select("*");
    }

    public function sqlSelect() // For backward compatibility
    {
        return $this->getSqlSelect();
    }

    public function setSqlSelect($v)
    {
        $this->SqlSelect = $v;
    }

    public function getSqlWhere() // Where
    {
        $where = ($this->SqlWhere != "") ? $this->SqlWhere : "";
        $this->DefaultFilter = "`tahun_pelajaran`='".tapel()."'";
        AddFilter($where, $this->DefaultFilter);
        return $where;
    }

    public function sqlWhere() // For backward compatibility
    {
        return $this->getSqlWhere();
    }

    public function setSqlWhere($v)
    {
        $this->SqlWhere = $v;
    }

    public function getSqlGroupBy() // Group By
    {
        return ($this->SqlGroupBy != "") ? $this->SqlGroupBy : "";
    }

    public function sqlGroupBy() // For backward compatibility
    {
        return $this->getSqlGroupBy();
    }

    public function setSqlGroupBy($v)
    {
        $this->SqlGroupBy = $v;
    }

    public function getSqlHaving() // Having
    {
        return ($this->SqlHaving != "") ? $this->SqlHaving : "";
    }

    public function sqlHaving() // For backward compatibility
    {
        return $this->getSqlHaving();
    }

    public function setSqlHaving($v)
    {
        $this->SqlHaving = $v;
    }

    public function getSqlOrderBy() // Order By
    {
        return ($this->SqlOrderBy != "") ? $this->SqlOrderBy : $this->DefaultSort;
    }

    public function sqlOrderBy() // For backward compatibility
    {
        return $this->getSqlOrderBy();
    }

    public function setSqlOrderBy($v)
    {
        $this->SqlOrderBy = $v;
    }

    // Apply User ID filters
    public function applyUserIDFilters($filter)
    {
        return $filter;
    }

    // Check if User ID security allows view all
    public function userIDAllow($id = "")
    {
        $allow = $this->UserIDAllowSecurity;
        switch ($id) {
            case "add":
            case "copy":
            case "gridadd":
            case "register":
            case "addopt":
                return (($allow & 1) == 1);
            case "edit":
            case "gridedit":
            case "update":
            case "changepassword":
            case "resetpassword":
                return (($allow & 4) == 4);
            case "delete":
                return (($allow & 2) == 2);
            case "view":
                return (($allow & 32) == 32);
            case "search":
                return (($allow & 64) == 64);
            default:
                return (($allow & 8) == 8);
        }
    }

    /**
     * Get record count
     *
     * @param string|QueryBuilder $sql SQL or QueryBuilder
     * @param mixed $c Connection
     * @return int
     */
    public function getRecordCount($sql, $c = null)
    {
        $cnt = -1;
        $rs = null;
        if ($sql instanceof \Doctrine\DBAL\Query\QueryBuilder) { // Query builder
            $sqlwrk = clone $sql;
            $sqlwrk = $sqlwrk->resetQueryPart("orderBy")->getSQL();
        } else {
            $sqlwrk = $sql;
        }
        $pattern = '/^SELECT\s([\s\S]+)\sFROM\s/i';
        // Skip Custom View / SubQuery / SELECT DISTINCT / ORDER BY
        if (
            ($this->TableType == 'TABLE' || $this->TableType == 'VIEW' || $this->TableType == 'LINKTABLE') &&
            preg_match($pattern, $sqlwrk) && !preg_match('/\(\s*(SELECT[^)]+)\)/i', $sqlwrk) &&
            !preg_match('/^\s*select\s+distinct\s+/i', $sqlwrk) && !preg_match('/\s+order\s+by\s+/i', $sqlwrk)
        ) {
            $sqlwrk = "SELECT COUNT(*) FROM " . preg_replace($pattern, "", $sqlwrk);
        } else {
            $sqlwrk = "SELECT COUNT(*) FROM (" . $sqlwrk . ") COUNT_TABLE";
        }
        $conn = $c ?? $this->getConnection();
        $rs = $conn->executeQuery($sqlwrk);
        $cnt = $rs->fetchColumn();
        if ($cnt !== false) {
            return (int)$cnt;
        }

        // Unable to get count by SELECT COUNT(*), execute the SQL to get record count directly
        return ExecuteRecordCount($sql, $conn);
    }

    // Get SQL
    public function getSql($where, $orderBy = "")
    {
        return $this->buildSelectSql(
            $this->getSqlSelect(),
            $this->getSqlFrom(),
            $this->getSqlWhere(),
            $this->getSqlGroupBy(),
            $this->getSqlHaving(),
            $this->getSqlOrderBy(),
            $where,
            $orderBy
        )->getSQL();
    }

    // Table SQL
    public function getCurrentSql()
    {
        $filter = $this->CurrentFilter;
        $filter = $this->applyUserIDFilters($filter);
        $sort = $this->getSessionOrderBy();
        return $this->getSql($filter, $sort);
    }

    /**
     * Table SQL with List page filter
     *
     * @return QueryBuilder
     */
    public function getListSql()
    {
        $filter = $this->UseSessionForListSql ? $this->getSessionWhere() : "";
        AddFilter($filter, $this->CurrentFilter);
        $filter = $this->applyUserIDFilters($filter);
        $this->recordsetSelecting($filter);
        $select = $this->getSqlSelect();
        $from = $this->getSqlFrom();
        $sort = $this->UseSessionForListSql ? $this->getSessionOrderBy() : "";
        $this->Sort = $sort;
        return $this->buildSelectSql(
            $select,
            $from,
            $this->getSqlWhere(),
            $this->getSqlGroupBy(),
            $this->getSqlHaving(),
            $this->getSqlOrderBy(),
            $filter,
            $sort
        );
    }

    // Get ORDER BY clause
    public function getOrderBy()
    {
        $orderBy = $this->getSqlOrderBy();
        $sort = $this->getSessionOrderBy();
        if ($orderBy != "" && $sort != "") {
            $orderBy .= ", " . $sort;
        } elseif ($sort != "") {
            $orderBy = $sort;
        }
        return $orderBy;
    }

    // Get record count based on filter (for detail record count in master table pages)
    public function loadRecordCount($filter)
    {
        $origFilter = $this->CurrentFilter;
        $this->CurrentFilter = $filter;
        $this->recordsetSelecting($this->CurrentFilter);
        $select = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlSelect() : $this->getQueryBuilder()->select("*");
        $groupBy = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlGroupBy() : "";
        $having = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlHaving() : "";
        $sql = $this->buildSelectSql($select, $this->getSqlFrom(), $this->getSqlWhere(), $groupBy, $having, "", $this->CurrentFilter, "");
        $cnt = $this->getRecordCount($sql);
        $this->CurrentFilter = $origFilter;
        return $cnt;
    }

    // Get record count (for current List page)
    public function listRecordCount()
    {
        $filter = $this->getSessionWhere();
        AddFilter($filter, $this->CurrentFilter);
        $filter = $this->applyUserIDFilters($filter);
        $this->recordsetSelecting($filter);
        $select = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlSelect() : $this->getQueryBuilder()->select("*");
        $groupBy = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlGroupBy() : "";
        $having = $this->TableType == 'CUSTOMVIEW' ? $this->getSqlHaving() : "";
        $sql = $this->buildSelectSql($select, $this->getSqlFrom(), $this->getSqlWhere(), $groupBy, $having, "", $filter, "");
        $cnt = $this->getRecordCount($sql);
        return $cnt;
    }

    /**
     * INSERT statement
     *
     * @param mixed $rs
     * @return QueryBuilder
     */
    protected function insertSql(&$rs)
    {
        $queryBuilder = $this->getQueryBuilder();
        $queryBuilder->insert($this->UpdateTable);
        foreach ($rs as $name => $value) {
            if (!isset($this->Fields[$name]) || $this->Fields[$name]->IsCustom) {
                continue;
            }
            $type = GetParameterType($this->Fields[$name], $value, $this->Dbid);
            $queryBuilder->setValue($this->Fields[$name]->Expression, $queryBuilder->createPositionalParameter($value, $type));
        }
        return $queryBuilder;
    }

    // Insert
    public function insert(&$rs)
    {
        $conn = $this->getConnection();
        $success = $this->insertSql($rs)->execute();
        if ($success) {
            // Get insert id if necessary
            $this->project_id->setDbValue($conn->lastInsertId());
            $rs['project_id'] = $this->project_id->DbValue;
        }
        return $success;
    }

    /**
     * UPDATE statement
     *
     * @param array $rs Data to be updated
     * @param string|array $where WHERE clause
     * @param string $curfilter Filter
     * @return QueryBuilder
     */
    protected function updateSql(&$rs, $where = "", $curfilter = true)
    {
        $queryBuilder = $this->getQueryBuilder();
        $queryBuilder->update($this->UpdateTable);
        foreach ($rs as $name => $value) {
            if (!isset($this->Fields[$name]) || $this->Fields[$name]->IsCustom || $this->Fields[$name]->IsAutoIncrement) {
                continue;
            }
            $type = GetParameterType($this->Fields[$name], $value, $this->Dbid);
            $queryBuilder->set($this->Fields[$name]->Expression, $queryBuilder->createPositionalParameter($value, $type));
        }
        $filter = ($curfilter) ? $this->CurrentFilter : "";
        if (is_array($where)) {
            $where = $this->arrayToFilter($where);
        }
        AddFilter($filter, $where);
        if ($filter != "") {
            $queryBuilder->where($filter);
        }
        return $queryBuilder;
    }

    // Update
    public function update(&$rs, $where = "", $rsold = null, $curfilter = true)
    {
        // Cascade Update detail table 'nilai_p5'
        $cascadeUpdate = false;
        $rscascade = [];
        if ($rsold && (isset($rs['kelas']) && $rsold['kelas'] != $rs['kelas'])) { // Update detail field 'kelas'
            $cascadeUpdate = true;
            $rscascade['kelas'] = $rs['kelas'];
        }
        if ($rsold && (isset($rs['project']) && $rsold['project'] != $rs['project'])) { // Update detail field 'proyek'
            $cascadeUpdate = true;
            $rscascade['proyek'] = $rs['project'];
        }
        if ($cascadeUpdate) {
            $rswrk = Container("nilai_p5")->loadRs("\"kelas\" = " . QuotedValue($rsold['kelas'], DATATYPE_MEMO, 'DB') . " AND " . "\"proyek\" = " . QuotedValue($rsold['project'], DATATYPE_STRING, 'DB'))->fetchAll(\PDO::FETCH_ASSOC);
            foreach ($rswrk as $rsdtlold) {
                $rskey = [];
                $fldname = 'nilai_p5';
                $rskey[$fldname] = $rsdtlold[$fldname];
                $rsdtlnew = array_merge($rsdtlold, $rscascade);
                // Call Row_Updating event
                $success = Container("nilai_p5")->rowUpdating($rsdtlold, $rsdtlnew);
                if ($success) {
                    $success = Container("nilai_p5")->update($rscascade, $rskey, $rsdtlold);
                }
                if (!$success) {
                    return false;
                }
                // Call Row_Updated event
                Container("nilai_p5")->rowUpdated($rsdtlold, $rsdtlnew);
            }
        }

        // If no field is updated, execute may return 0. Treat as success
        $success = $this->updateSql($rs, $where, $curfilter)->execute();
        $success = ($success > 0) ? $success : true;
        return $success;
    }

    /**
     * DELETE statement
     *
     * @param array $rs Key values
     * @param string|array $where WHERE clause
     * @param string $curfilter Filter
     * @return QueryBuilder
     */
    protected function deleteSql(&$rs, $where = "", $curfilter = true)
    {
        $queryBuilder = $this->getQueryBuilder();
        $queryBuilder->delete($this->UpdateTable);
        if (is_array($where)) {
            $where = $this->arrayToFilter($where);
        }
        if ($rs) {
            if (array_key_exists('project_id', $rs)) {
                AddFilter($where, QuotedName('project_id', $this->Dbid) . '=' . QuotedValue($rs['project_id'], $this->project_id->DataType, $this->Dbid));
            }
        }
        $filter = ($curfilter) ? $this->CurrentFilter : "";
        AddFilter($filter, $where);
        return $queryBuilder->where($filter != "" ? $filter : "0=1");
    }

    // Delete
    public function delete(&$rs, $where = "", $curfilter = false)
    {
        $success = true;

        // Cascade delete detail table 'nilai_p5'
        $dtlrows = Container("nilai_p5")->loadRs("\"kelas\" = " . QuotedValue($rs['kelas'], DATATYPE_MEMO, "DB") . " AND " . "\"proyek\" = " . QuotedValue($rs['project'], DATATYPE_STRING, "DB"))->fetchAll(\PDO::FETCH_ASSOC);
        // Call Row Deleting event
        foreach ($dtlrows as $dtlrow) {
            $success = Container("nilai_p5")->rowDeleting($dtlrow);
            if (!$success) {
                break;
            }
        }
        if ($success) {
            foreach ($dtlrows as $dtlrow) {
                $success = Container("nilai_p5")->delete($dtlrow); // Delete
                if (!$success) {
                    break;
                }
            }
        }
        // Call Row Deleted event
        if ($success) {
            foreach ($dtlrows as $dtlrow) {
                Container("nilai_p5")->rowDeleted($dtlrow);
            }
        }
        if ($success) {
            $success = $this->deleteSql($rs, $where, $curfilter)->execute();
        }
        return $success;
    }

    // Load DbValue from recordset or array
    protected function loadDbValues($row)
    {
        if (!is_array($row)) {
            return;
        }
        $this->project_id->DbValue = $row['project_id'];
        $this->tahun_pelajaran->DbValue = $row['tahun_pelajaran'];
        $this->kelas->DbValue = $row['kelas'];
        $this->project->DbValue = $row['project'];
        $this->nama_proyek->DbValue = $row['nama_proyek'];
        $this->tema->DbValue = $row['tema'];
        $this->dimensi->DbValue = $row['dimensi'];
        $this->deskripsi_proyek->DbValue = $row['deskripsi_proyek'];
    }

    // Delete uploaded files
    public function deleteUploadedFiles($row)
    {
        $this->loadDbValues($row);
    }

    // Record filter WHERE clause
    protected function sqlKeyFilter()
    {
        return "\"project_id\" = @project_id@";
    }

    // Get Key
    public function getKey($current = false)
    {
        $keys = [];
        $val = $current ? $this->project_id->CurrentValue : $this->project_id->OldValue;
        if (EmptyValue($val)) {
            return "";
        } else {
            $keys[] = $val;
        }
        return implode(Config("COMPOSITE_KEY_SEPARATOR"), $keys);
    }

    // Set Key
    public function setKey($key, $current = false)
    {
        $this->OldKey = strval($key);
        $keys = explode(Config("COMPOSITE_KEY_SEPARATOR"), $this->OldKey);
        if (count($keys) == 1) {
            if ($current) {
                $this->project_id->CurrentValue = $keys[0];
            } else {
                $this->project_id->OldValue = $keys[0];
            }
        }
    }

    // Get record filter
    public function getRecordFilter($row = null)
    {
        $keyFilter = $this->sqlKeyFilter();
        if (is_array($row)) {
            $val = array_key_exists('project_id', $row) ? $row['project_id'] : null;
        } else {
            $val = $this->project_id->OldValue !== null ? $this->project_id->OldValue : $this->project_id->CurrentValue;
        }
        if (!is_numeric($val)) {
            return "0=1"; // Invalid key
        }
        if ($val === null) {
            return "0=1"; // Invalid key
        } else {
            $keyFilter = str_replace("@project_id@", AdjustSql($val, $this->Dbid), $keyFilter); // Replace key value
        }
        return $keyFilter;
    }

    // Return page URL
    public function getReturnUrl()
    {
        $referUrl = ReferUrl();
        $referPageName = ReferPageName();
        $name = PROJECT_NAME . "_" . $this->TableVar . "_" . Config("TABLE_RETURN_URL");
        // Get referer URL automatically
        if ($referUrl != "" && $referPageName != CurrentPageName() && $referPageName != "login") { // Referer not same page or login page
            $_SESSION[$name] = $referUrl; // Save to Session
        }
        return $_SESSION[$name] ?? GetUrl("ProyekList");
    }

    // Set return page URL
    public function setReturnUrl($v)
    {
        $_SESSION[PROJECT_NAME . "_" . $this->TableVar . "_" . Config("TABLE_RETURN_URL")] = $v;
    }

    // Get modal caption
    public function getModalCaption($pageName)
    {
        global $Language;
        if ($pageName == "ProyekView") {
            return $Language->phrase("View");
        } elseif ($pageName == "ProyekEdit") {
            return $Language->phrase("Edit");
        } elseif ($pageName == "ProyekAdd") {
            return $Language->phrase("Add");
        } else {
            return "";
        }
    }

    // API page name
    public function getApiPageName($action)
    {
        switch (strtolower($action)) {
            case Config("API_VIEW_ACTION"):
                return "ProyekView";
            case Config("API_ADD_ACTION"):
                return "ProyekAdd";
            case Config("API_EDIT_ACTION"):
                return "ProyekEdit";
            case Config("API_DELETE_ACTION"):
                return "ProyekDelete";
            case Config("API_LIST_ACTION"):
                return "ProyekList";
            default:
                return "";
        }
    }

    // List URL
    public function getListUrl()
    {
        return "ProyekList";
    }

    // View URL
    public function getViewUrl($parm = "")
    {
        if ($parm != "") {
            $url = $this->keyUrl("ProyekView", $this->getUrlParm($parm));
        } else {
            $url = $this->keyUrl("ProyekView", $this->getUrlParm(Config("TABLE_SHOW_DETAIL") . "="));
        }
        return $this->addMasterUrl($url);
    }

    // Add URL
    public function getAddUrl($parm = "")
    {
        if ($parm != "") {
            $url = "ProyekAdd?" . $this->getUrlParm($parm);
        } else {
            $url = "ProyekAdd";
        }
        return $this->addMasterUrl($url);
    }

    // Edit URL
    public function getEditUrl($parm = "")
    {
        if ($parm != "") {
            $url = $this->keyUrl("ProyekEdit", $this->getUrlParm($parm));
        } else {
            $url = $this->keyUrl("ProyekEdit", $this->getUrlParm(Config("TABLE_SHOW_DETAIL") . "="));
        }
        return $this->addMasterUrl($url);
    }

    // Inline edit URL
    public function getInlineEditUrl()
    {
        $url = $this->keyUrl(CurrentPageName(), $this->getUrlParm("action=edit"));
        return $this->addMasterUrl($url);
    }

    // Copy URL
    public function getCopyUrl($parm = "")
    {
        if ($parm != "") {
            $url = $this->keyUrl("ProyekAdd", $this->getUrlParm($parm));
        } else {
            $url = $this->keyUrl("ProyekAdd", $this->getUrlParm(Config("TABLE_SHOW_DETAIL") . "="));
        }
        return $this->addMasterUrl($url);
    }

    // Inline copy URL
    public function getInlineCopyUrl()
    {
        $url = $this->keyUrl(CurrentPageName(), $this->getUrlParm("action=copy"));
        return $this->addMasterUrl($url);
    }

    // Delete URL
    public function getDeleteUrl()
    {
        return $this->keyUrl("ProyekDelete", $this->getUrlParm());
    }

    // Add master url
    public function addMasterUrl($url)
    {
        return $url;
    }

    public function keyToJson($htmlEncode = false)
    {
        $json = "";
        $json .= "project_id:" . JsonEncode($this->project_id->CurrentValue, "number");
        $json = "{" . $json . "}";
        if ($htmlEncode) {
            $json = HtmlEncode($json);
        }
        return $json;
    }

    // Add key value to URL
    public function keyUrl($url, $parm = "")
    {
        if ($this->project_id->CurrentValue !== null) {
            $url .= "/" . rawurlencode($this->project_id->CurrentValue);
        } else {
            return "javascript:ew.alert(ew.language.phrase('InvalidRecord'));";
        }
        if ($parm != "") {
            $url .= "?" . $parm;
        }
        return $url;
    }

    // Render sort
    public function renderSort($fld)
    {
        $classId = $fld->TableVar . "_" . $fld->Param;
        $scriptId = str_replace("%id%", $classId, "tpc_%id%");
        $scriptStart = $this->UseCustomTemplate ? "<template id=\"" . $scriptId . "\">" : "";
        $scriptEnd = $this->UseCustomTemplate ? "</template>" : "";
        $jsSort = " class=\"ew-pointer\" onclick=\"ew.sort(event, '" . $this->sortUrl($fld) . "', 1);\"";
        if ($this->sortUrl($fld) == "") {
            $html = <<<NOSORTHTML
{$scriptStart}<div class="ew-table-header-caption">{$fld->caption()}</div>{$scriptEnd}
NOSORTHTML;
        } else {
            if ($fld->getSort() == "ASC") {
                $sortIcon = '<i class="fas fa-sort-up"></i>';
            } elseif ($fld->getSort() == "DESC") {
                $sortIcon = '<i class="fas fa-sort-down"></i>';
            } else {
                $sortIcon = '';
            }
            $html = <<<SORTHTML
{$scriptStart}<div{$jsSort}><div class="ew-table-header-btn"><span class="ew-table-header-caption">{$fld->caption()}</span><span class="ew-table-header-sort">{$sortIcon}</span></div></div>{$scriptEnd}
SORTHTML;
        }
        return $html;
    }

    // Sort URL
    public function sortUrl($fld)
    {
        if (
            $this->CurrentAction || $this->isExport() ||
            in_array($fld->Type, [141, 201, 203, 128, 204, 205])
        ) { // Unsortable data type
                return "";
        } elseif ($fld->Sortable) {
            $urlParm = $this->getUrlParm("order=" . urlencode($fld->Name) . "&amp;ordertype=" . $fld->getNextSort());
            return $this->addMasterUrl(CurrentPageName() . "?" . $urlParm);
        } else {
            return "";
        }
    }

    // Get record keys from Post/Get/Session
    public function getRecordKeys()
    {
        $arKeys = [];
        $arKey = [];
        if (Param("key_m") !== null) {
            $arKeys = Param("key_m");
            $cnt = count($arKeys);
        } else {
            if (($keyValue = Param("project_id") ?? Route("project_id")) !== null) {
                $arKeys[] = $keyValue;
            } elseif (IsApi() && (($keyValue = Key(0) ?? Route(2)) !== null)) {
                $arKeys[] = $keyValue;
            } else {
                $arKeys = null; // Do not setup
            }

            //return $arKeys; // Do not return yet, so the values will also be checked by the following code
        }
        // Check keys
        $ar = [];
        if (is_array($arKeys)) {
            foreach ($arKeys as $key) {
                if (!is_numeric($key)) {
                    continue;
                }
                $ar[] = $key;
            }
        }
        return $ar;
    }

    // Get filter from record keys
    public function getFilterFromRecordKeys($setCurrent = true)
    {
        $arKeys = $this->getRecordKeys();
        $keyFilter = "";
        foreach ($arKeys as $key) {
            if ($keyFilter != "") {
                $keyFilter .= " OR ";
            }
            if ($setCurrent) {
                $this->project_id->CurrentValue = $key;
            } else {
                $this->project_id->OldValue = $key;
            }
            $keyFilter .= "(" . $this->getRecordFilter() . ")";
        }
        return $keyFilter;
    }

    // Load recordset based on filter
    public function &loadRs($filter)
    {
        $sql = $this->getSql($filter); // Set up filter (WHERE Clause)
        $conn = $this->getConnection();
        $stmt = $conn->executeQuery($sql);
        return $stmt;
    }

    // Load row values from record
    public function loadListRowValues(&$rs)
    {
        if (is_array($rs)) {
            $row = $rs;
        } elseif ($rs && property_exists($rs, "fields")) { // Recordset
            $row = $rs->fields;
        } else {
            return;
        }
        $this->project_id->setDbValue($row['project_id']);
        $this->tahun_pelajaran->setDbValue($row['tahun_pelajaran']);
        $this->kelas->setDbValue($row['kelas']);
        $this->project->setDbValue($row['project']);
        $this->nama_proyek->setDbValue($row['nama_proyek']);
        $this->tema->setDbValue($row['tema']);
        $this->dimensi->setDbValue($row['dimensi']);
        $this->deskripsi_proyek->setDbValue($row['deskripsi_proyek']);
    }

    // Render list row values
    public function renderListRow()
    {
        global $Security, $CurrentLanguage, $Language;

        // Call Row Rendering event
        $this->rowRendering();

        // Common render codes

        // project_id
        $this->project_id->CellCssStyle = "white-space: nowrap;";

        // tahun_pelajaran
        $this->tahun_pelajaran->CellCssStyle = "white-space: nowrap;";

        // kelas
        $this->kelas->CellCssStyle = "white-space: nowrap;";

        // project
        $this->project->CellCssStyle = "white-space: nowrap;";

        // nama_proyek
        $this->nama_proyek->CellCssStyle = "white-space: nowrap;";

        // tema
        $this->tema->CellCssStyle = "white-space: nowrap;";

        // dimensi
        $this->dimensi->CellCssStyle = "white-space: nowrap;";

        // deskripsi_proyek
        $this->deskripsi_proyek->CellCssStyle = "white-space: nowrap;";

        // project_id
        $this->project_id->ViewValue = $this->project_id->CurrentValue;
        $this->project_id->ViewCustomAttributes = "";

        // tahun_pelajaran
        $curVal = trim(strval($this->tahun_pelajaran->CurrentValue));
        if ($curVal != "") {
            $this->tahun_pelajaran->ViewValue = $this->tahun_pelajaran->lookupCacheOption($curVal);
            if ($this->tahun_pelajaran->ViewValue === null) { // Lookup from database
                $filterWrk = "\"tahun_pelajaran\"" . SearchString("=", $curVal, DATATYPE_STRING, "");
                $lookupFilter = function() {
                    return "`tahun_pelajaran`='".tapel()."'";
                };
                $lookupFilter = $lookupFilter->bindTo($this);
                $sqlWrk = $this->tahun_pelajaran->Lookup->getSql(false, $filterWrk, $lookupFilter, $this, true, true);
                $rswrk = Conn()->executeQuery($sqlWrk)->fetchAll(\PDO::FETCH_BOTH);
                $ari = count($rswrk);
                if ($ari > 0) { // Lookup values found
                    $arwrk = $this->tahun_pelajaran->Lookup->renderViewRow($rswrk[0]);
                    $this->tahun_pelajaran->ViewValue = $this->tahun_pelajaran->displayValue($arwrk);
                } else {
                    $this->tahun_pelajaran->ViewValue = $this->tahun_pelajaran->CurrentValue;
                }
            }
        } else {
            $this->tahun_pelajaran->ViewValue = null;
        }
        $this->tahun_pelajaran->ViewCustomAttributes = "";

        // kelas
        $this->kelas->ViewValue = $this->kelas->CurrentValue;
        $this->kelas->ViewCustomAttributes = "";

        // project
        if (strval($this->project->CurrentValue) != "") {
            $this->project->ViewValue = $this->project->optionCaption($this->project->CurrentValue);
        } else {
            $this->project->ViewValue = null;
        }
        $this->project->ViewCustomAttributes = "";

        // nama_proyek
        $this->nama_proyek->ViewValue = $this->nama_proyek->CurrentValue;
        $this->nama_proyek->ViewCustomAttributes = "";

        // tema
        $curVal = trim(strval($this->tema->CurrentValue));
        if ($curVal != "") {
            $this->tema->ViewValue = $this->tema->lookupCacheOption($curVal);
            if ($this->tema->ViewValue === null) { // Lookup from database
                $filterWrk = "\"tema_id\"" . SearchString("=", $curVal, DATATYPE_NUMBER, "");
                $sqlWrk = $this->tema->Lookup->getSql(false, $filterWrk, '', $this, true, true);
                $rswrk = Conn()->executeQuery($sqlWrk)->fetchAll(\PDO::FETCH_BOTH);
                $ari = count($rswrk);
                if ($ari > 0) { // Lookup values found
                    $arwrk = $this->tema->Lookup->renderViewRow($rswrk[0]);
                    $this->tema->ViewValue = $this->tema->displayValue($arwrk);
                } else {
                    $this->tema->ViewValue = $this->tema->CurrentValue;
                }
            }
        } else {
            $this->tema->ViewValue = null;
        }
        $this->tema->ViewCustomAttributes = "";

        // dimensi
        $curVal = trim(strval($this->dimensi->CurrentValue));
        if ($curVal != "") {
            $this->dimensi->ViewValue = $this->dimensi->lookupCacheOption($curVal);
            if ($this->dimensi->ViewValue === null) { // Lookup from database
                $arwrk = explode(",", $curVal);
                $filterWrk = "";
                foreach ($arwrk as $wrk) {
                    if ($filterWrk != "") {
                        $filterWrk .= " OR ";
                    }
                    $filterWrk .= "\"dimensi_id\"" . SearchString("=", trim($wrk), DATATYPE_NUMBER, "");
                }
                $sqlWrk = $this->dimensi->Lookup->getSql(false, $filterWrk, '', $this, true, true);
                $rswrk = Conn()->executeQuery($sqlWrk)->fetchAll(\PDO::FETCH_BOTH);
                $ari = count($rswrk);
                if ($ari > 0) { // Lookup values found
                    $this->dimensi->ViewValue = new OptionValues();
                    foreach ($rswrk as $row) {
                        $arwrk = $this->dimensi->Lookup->renderViewRow($row);
                        $this->dimensi->ViewValue->add($this->dimensi->displayValue($arwrk));
                    }
                } else {
                    $this->dimensi->ViewValue = $this->dimensi->CurrentValue;
                }
            }
        } else {
            $this->dimensi->ViewValue = null;
        }
        $this->dimensi->ViewCustomAttributes = "";

        // deskripsi_proyek
        $this->deskripsi_proyek->ViewValue = $this->deskripsi_proyek->CurrentValue;
        $this->deskripsi_proyek->ViewCustomAttributes = "";

        // project_id
        $this->project_id->LinkCustomAttributes = "";
        $this->project_id->HrefValue = "";
        $this->project_id->TooltipValue = "";

        // tahun_pelajaran
        $this->tahun_pelajaran->LinkCustomAttributes = "";
        $this->tahun_pelajaran->HrefValue = "";
        $this->tahun_pelajaran->TooltipValue = "";

        // kelas
        $this->kelas->LinkCustomAttributes = "";
        $this->kelas->HrefValue = "";
        $this->kelas->TooltipValue = "";

        // project
        $this->project->LinkCustomAttributes = "";
        $this->project->HrefValue = "";
        $this->project->TooltipValue = "";

        // nama_proyek
        $this->nama_proyek->LinkCustomAttributes = "";
        $this->nama_proyek->HrefValue = "";
        $this->nama_proyek->TooltipValue = "";

        // tema
        $this->tema->LinkCustomAttributes = "";
        $this->tema->HrefValue = "";
        $this->tema->TooltipValue = "";

        // dimensi
        $this->dimensi->LinkCustomAttributes = "";
        $this->dimensi->HrefValue = "";
        $this->dimensi->TooltipValue = "";

        // deskripsi_proyek
        $this->deskripsi_proyek->LinkCustomAttributes = "";
        $this->deskripsi_proyek->HrefValue = "";
        $this->deskripsi_proyek->TooltipValue = "";

        // Call Row Rendered event
        $this->rowRendered();

        // Save data for Custom Template
        $this->Rows[] = $this->customTemplateFieldValues();
    }

    // Render edit row values
    public function renderEditRow()
    {
        global $Security, $CurrentLanguage, $Language;

        // Call Row Rendering event
        $this->rowRendering();

        // project_id
        $this->project_id->EditAttrs["class"] = "form-control";
        $this->project_id->EditCustomAttributes = "";
        $this->project_id->EditValue = $this->project_id->CurrentValue;
        $this->project_id->ViewCustomAttributes = "";

        // tahun_pelajaran
        $this->tahun_pelajaran->EditAttrs["class"] = "form-control";
        $this->tahun_pelajaran->EditCustomAttributes = "";

        // kelas
        $this->kelas->EditAttrs["class"] = "form-control";
        $this->kelas->EditCustomAttributes = "";

        // project
        $this->project->EditAttrs["class"] = "form-control";
        $this->project->EditCustomAttributes = "";
        $this->project->EditValue = $this->project->options(true);

        // nama_proyek
        $this->nama_proyek->EditAttrs["class"] = "form-control";
        $this->nama_proyek->EditCustomAttributes = "";
        if (!$this->nama_proyek->Raw) {
            $this->nama_proyek->CurrentValue = HtmlDecode($this->nama_proyek->CurrentValue);
        }
        $this->nama_proyek->EditValue = $this->nama_proyek->CurrentValue;

        // tema
        $this->tema->EditAttrs["class"] = "form-control";
        $this->tema->EditCustomAttributes = "";

        // dimensi
        $this->dimensi->EditAttrs["class"] = "form-control";
        $this->dimensi->EditCustomAttributes = "";

        // deskripsi_proyek
        $this->deskripsi_proyek->EditAttrs["class"] = "form-control";
        $this->deskripsi_proyek->EditCustomAttributes = "";
        $this->deskripsi_proyek->EditValue = $this->deskripsi_proyek->CurrentValue;

        // Call Row Rendered event
        $this->rowRendered();
    }

    // Aggregate list row values
    public function aggregateListRowValues()
    {
    }

    // Aggregate list row (for rendering)
    public function aggregateListRow()
    {
        // Call Row Rendered event
        $this->rowRendered();
    }

    // Export data in HTML/CSV/Word/Excel/Email/PDF format
    public function exportDocument($doc, $recordset, $startRec = 1, $stopRec = 1, $exportPageType = "")
    {
        if (!$recordset || !$doc) {
            return;
        }
        if (!$doc->ExportCustom) {
            // Write header
            $doc->exportTableHeader();
            if ($doc->Horizontal) { // Horizontal format, write header
                $doc->beginExportRow();
                if ($exportPageType == "view") {
                    $doc->exportCaption($this->tahun_pelajaran);
                    $doc->exportCaption($this->kelas);
                    $doc->exportCaption($this->project);
                    $doc->exportCaption($this->nama_proyek);
                    $doc->exportCaption($this->tema);
                    $doc->exportCaption($this->dimensi);
                    $doc->exportCaption($this->deskripsi_proyek);
                } else {
                    $doc->exportCaption($this->project_id);
                    $doc->exportCaption($this->tahun_pelajaran);
                    $doc->exportCaption($this->kelas);
                    $doc->exportCaption($this->project);
                    $doc->exportCaption($this->nama_proyek);
                    $doc->exportCaption($this->tema);
                    $doc->exportCaption($this->dimensi);
                    $doc->exportCaption($this->deskripsi_proyek);
                }
                $doc->endExportRow();
            }
        }

        // Move to first record
        $recCnt = $startRec - 1;
        $stopRec = ($stopRec > 0) ? $stopRec : PHP_INT_MAX;
        while (!$recordset->EOF && $recCnt < $stopRec) {
            $row = $recordset->fields;
            $recCnt++;
            if ($recCnt >= $startRec) {
                $rowCnt = $recCnt - $startRec + 1;

                // Page break
                if ($this->ExportPageBreakCount > 0) {
                    if ($rowCnt > 1 && ($rowCnt - 1) % $this->ExportPageBreakCount == 0) {
                        $doc->exportPageBreak();
                    }
                }
                $this->loadListRowValues($row);

                // Render row
                $this->RowType = ROWTYPE_VIEW; // Render view
                $this->resetAttributes();
                $this->renderListRow();
                if (!$doc->ExportCustom) {
                    $doc->beginExportRow($rowCnt); // Allow CSS styles if enabled
                    if ($exportPageType == "view") {
                        $doc->exportField($this->tahun_pelajaran);
                        $doc->exportField($this->kelas);
                        $doc->exportField($this->project);
                        $doc->exportField($this->nama_proyek);
                        $doc->exportField($this->tema);
                        $doc->exportField($this->dimensi);
                        $doc->exportField($this->deskripsi_proyek);
                    } else {
                        $doc->exportField($this->project_id);
                        $doc->exportField($this->tahun_pelajaran);
                        $doc->exportField($this->kelas);
                        $doc->exportField($this->project);
                        $doc->exportField($this->nama_proyek);
                        $doc->exportField($this->tema);
                        $doc->exportField($this->dimensi);
                        $doc->exportField($this->deskripsi_proyek);
                    }
                    $doc->endExportRow($rowCnt);
                }
            }

            // Call Row Export server event
            if ($doc->ExportCustom) {
                $this->rowExport($row);
            }
            $recordset->moveNext();
        }
        if (!$doc->ExportCustom) {
            $doc->exportTableFooter();
        }
    }

    // Get file data
    public function getFileData($fldparm, $key, $resize, $width = 0, $height = 0, $plugins = [])
    {
        // No binary fields
        return false;
    }

    // Table level events

    // Recordset Selecting event
    public function recordsetSelecting(&$filter)
    {
        // Enter your code here
    }

    // Recordset Selected event
    public function recordsetSelected(&$rs)
    {
        //Log("Recordset Selected");
    }

    // Recordset Search Validated event
    public function recordsetSearchValidated()
    {
        // Example:
        //$this->MyField1->AdvancedSearch->SearchValue = "your search criteria"; // Search value
    }

    // Recordset Searching event
    public function recordsetSearching(&$filter)
    {
        // Enter your code here
    }

    // Row_Selecting event
    public function rowSelecting(&$filter)
    {
        // Enter your code here
    }

    // Row Selected event
    public function rowSelected(&$rs)
    {
        //Log("Row Selected");
    }

    // Row Inserting event
    public function rowInserting($rsold, &$rsnew)
    {
        // Enter your code here
        // To cancel, set return value to false
        return true;
    }

    // Row Inserted event
    public function rowInserted($rsold, &$rsnew)
    {
        //Log("Row Inserted");
    }

    // Row Updating event
    public function rowUpdating($rsold, &$rsnew)
    {
        // Enter your code here
        // To cancel, set return value to false
        return true;
    }

    // Row Updated event
    public function rowUpdated($rsold, &$rsnew)
    {
        //Log("Row Updated");
    }

    // Row Update Conflict event
    public function rowUpdateConflict($rsold, &$rsnew)
    {
        // Enter your code here
        // To ignore conflict, set return value to false
        return true;
    }

    // Grid Inserting event
    public function gridInserting()
    {
        // Enter your code here
        // To reject grid insert, set return value to false
        return true;
    }

    // Grid Inserted event
    public function gridInserted($rsnew)
    {
        //Log("Grid Inserted");
    }

    // Grid Updating event
    public function gridUpdating($rsold)
    {
        // Enter your code here
        // To reject grid update, set return value to false
        return true;
    }

    // Grid Updated event
    public function gridUpdated($rsold, $rsnew)
    {
        //Log("Grid Updated");
    }

    // Row Deleting event
    public function rowDeleting(&$rs)
    {
        // Enter your code here
        // To cancel, set return value to False
        return true;
    }

    // Row Deleted event
    public function rowDeleted(&$rs)
    {
        //Log("Row Deleted");
    }

    // Email Sending event
    public function emailSending($email, &$args)
    {
        //var_dump($email); var_dump($args); exit();
        return true;
    }

    // Lookup Selecting event
    public function lookupSelecting($fld, &$filter)
    {
        //var_dump($fld->Name, $fld->Lookup, $filter); // Uncomment to view the filter
        // Enter your code here
    }

    // Row Rendering event
    public function rowRendering()
    {
        // Enter your code here
    }

    // Row Rendered event
    public function rowRendered()
    {
        // To view properties of field class, use:
        //var_dump($this-><FieldName>);
    }

    // User ID Filtering event
    public function userIdFiltering(&$filter)
    {
        // Enter your code here
    }
}
